module NexusCqrs
  class CommandExecutor
    def initialize(command_bus)
      @bus = command_bus

      register_commands
    end

    def execute(command)
      @bus.call(command)
    end

    def register_command(klass, handler)
      Rails.logger.debug("Registered #{klass} to #{handler}")
      @bus.register(klass.class, handler)
    end

    private

    def register_commands
      # TODO, Register Commands/Queries
    end
  end
end
