require_relative '../lib/nexus_cqrs'

class TestCommand < NexusCqrs::BaseCommand
end

class TestCommandHandler < NexusCqrs::BaseCommandHandler
end

class TestQuery < NexusCqrs::BaseQuery
end

class TestQueryHandler < NexusCqrs::BaseQueryHandler
end

describe NexusCqrs::CommandBus do
  let(:command_bus) { NexusCqrs::CommandBus.new }
  let(:test_command_handler) { TestCommandHandler.new }
  let(:test_query_handler) { TestQueryHandler.new }

  it "allows a command/query to be registered" do
    expect(command_bus.registered_handlers.size).to(be(0))

    command_bus.register(TestCommand, test_command_handler)

    expect(command_bus.registered_handlers.size).to(be(1))

    command_bus.register(TestQuery, test_query_handler)

    expect(command_bus.registered_handlers.size).to(be(2))
  end

  it "calls the correct handler" do
    dbl = double("TestCommandHandler")
    expect(dbl).to(receive(:call))

    command_bus.register(TestCommand, dbl)
    test_command = TestCommand.new
    command_bus.call(test_command)
  end
end
